
local L = AceLibrary("AceLocale-2.2"):new("NextStep")
local BF = AceLibrary("Babble-Faction-2.2")

L:RegisterTranslations("enUS", function()
	return {
	["NextStep - add faction item info in your tooltip"] = true,
	["Your %s reputation is too high"] = true,
	["Need %dEA to go your %s reputation is %s(%d rep with %dEA)"] = true,
	["You are already exalted with %s."] = true,
	["It is unusable. Your %s reputation is %s."] = true,
	["highest_name"] = true,
	["hightest_desc"] = true,

	["Need Cenarion Tactical Badge and Cenarion Combat Badge"] = true,
	["Need Cenarion Logistics Badge and Cenarion Combat Badge"] = true,
	["Need Cenarion Logistics Badge and Cenarion Tactical Badge"] = true,
	["Need Razzashi Coin and Hakkari Coin"] = true,
	["Need Zulian Coin and Hakkari Coin"] = true,
	["Need Zulian Coin and Razzashi Coin"] = true,
	["Need Vilebranch Coin and Witherbark Coin"] = true,
	["Need Gurubashi Coin and Witherbark Coin"] = true,
	["Need Gurubashi Coin and Vilebranch Coin"] = true,
	["Need Skullsplitter Coin and Bloodscalp Coin"] = true,
	["Need Sandfury Coin and Bloodscalp Coin"] = true,
	["Need Sandfury Coin and Skullsplitter Coin"] = true,

}
end)

L:RegisterTranslations("koKR", function()
	return {
	["NextStep - add faction item info in your tooltip"] = "NextStep - 툴팁에 평판 아이템 관련 정보를 표시합니다",
	["Your %s reputation is too high"] = "%s에 대하여 더이상 사용할 수 없습니다",
	["Need %dEA to go your %s reputation is %s(%d rep with %dEA)"] = "%2$s에 대하여 %3$s까지 %1$d개 필요(%5$d개당 %4$d의 평판)",
	["You are already exalted with %s."] = "%s|1은;는; 이미 확고한 동맹입니다",
	["It is unusable. Your %s reputation is %s."] = "사용 불가능. 적대진영인 %s|1이;가; %s 평판입니다",
	["highest_name"] = "최대 등급 표시",
	["hightest_desc"] = "해당 아이템으로 올릴 수 있는 최고 등급의 평판까지의 필요한 갯수를 표시합니다",

	["Need Cenarion Tactical Badge and Cenarion Combat Badge"] = "세나리온 전술 휘장, 세나리온 전투 휘장 필요",
	["Need Cenarion Logistics Badge and Cenarion Combat Badge"] = "세나리온 병참 휘장, 세나리온 전투 휘장 필요",
	["Need Cenarion Logistics Badge and Cenarion Tactical Badge"] = "세나리온 전술 휘장, 세나리온 병참 휘장 필요",
	["Need Razzashi Coin and Hakkari Coin"] = "래즈자쉬부족 주화, 학카리부족 주화 필요",
	["Need Zulian Coin and Hakkari Coin"] = "줄리안부족 주화, 학카리부족 주화 필요",
	["Need Zulian Coin and Razzashi Coin"] = "줄리안부족 주화, 래즈자쉬부족 주화 필요",
	["Need Vilebranch Coin and Witherbark Coin"] = "썩은가지부족 주화, 마른나무껍질부족 주화 필요",
	["Need Gurubashi Coin and Witherbark Coin"] = "구루바시부족 주화, 마른나무껍질부족 주화 필요",
	["Need Gurubashi Coin and Vilebranch Coin"] = "구루바시부족 주화, 썩은가지부족 주화 필요",
	["Need Skullsplitter Coin and Bloodscalp Coin"] = "백골가루부족 주화, 붉은머리부족 주화 필요",
	["Need Sandfury Coin and Bloodscalp Coin"] = "성난모래부족 주화, 붉은머리부족 주화 필요",
	["Need Sandfury Coin and Skullsplitter Coin"] = "성난모래부족 주화, 백골가루부족 주화 필요",
}
end)

local NS_Point = {
	[1] = -42000,
	[2] = -6000,
	[3] = -3000,
	[4] = 0,
	[5] = 3000,
	[6] = 9000,
	[7] = 21000,
	[8] = 42000,
}

NextStep = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceHook-2.1", "AceModuleCore-2.0", "AceConsole-2.0", "AceDB-2.0")

NextStep.value = 0

NextStep.options = {
    desc = L["NextStep - add faction item info in your tooltip"],
	type = "group",
	args = {
		highest = {
			name = L["highest_name"],
			type = "toggle",
			desc = L["hightest_desc"],
			get = function() return NextStep.db.account.Highest end,
			set = function(v) NextStep.db.account.Highest = v end,
		},
	},
}

NextStep:RegisterChatCommand({"/nextstep", "/ns"}, NextStep.options)

NextStep:RegisterDB("NextStepDB")
NextStep:RegisterDefaults("account", {
	ItemInfo = {
	        ["25433"] = {
			[1] = {
				[1] = BF["The Mag'har"],
				[2] = "10",
				[3] = "250",
				[4] = "8",
			},
			[2] = {
				[1] = BF["The Consortium"],
				[2] = "10",
				[3] = "250",
				[4] = "8",
			},
		},
	        ["29209"] = {
			[1] = {
				[1] = BF["The Consortium"],
				[2] = "10",
				[3] = "250",
				[4] = "8",
			},
		},
		["29739"] = {
			[1] = {
				[1] = BF["The Scryers"],
				[2] = "1",
				[3] = "250",
				[4] = "8",
				[5] = BF["The Aldor"].."|4",
			},
		},
		["29426"] = {
			[1] = {
				[1] = BF["The Scryers"],
				[2] = "1",
				[3] = "25",
				[4] = "6",
				[5] = BF["The Aldor"].."|4",
			},
		},
		["30810"] = {
			[1] = {
				[1] = BF["The Scryers"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[5] = BF["The Aldor"].."|4",
			},
		},
		["25744"] = {
			[1] = {
				[1] = BF["The Scryers"],
				[2] = "8",
				[3] = "250",
				[4] = "4",
				[5] = BF["The Aldor"].."|9",
			},
		},
		["29740"] = {
			[1] = {
				[1] = BF["The Aldor"],
				[2] = "1",
				[3] = "250",
				[4] = "8",
				[5] = BF["The Scryers"].."|4",
			},
		},
		["29425"] = {
			[1] = {
				[1] = BF["The Aldor"],
				[2] = "1",
				[3] = "25",
				[4] = "6",
				[5] = BF["The Scryers"].."|4",
			},
		},
		["30809"] = {
			[1] = {
				[1] = BF["The Aldor"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[5] = BF["The Scryers"].."|4",
			},
		},
		["25802"] = {
			[1] = {
				[1] = BF["The Aldor"],
				[2] = "8",
				[3] = "250",
				[4] = "4",
				[5] = BF["The Scryers"].."|9",
			},
		},
		["25719"] = {
			[1] = {
				[1] = BF["Lower City"],
				[2] = "30",
				[3] = "250",
				[4] = "5",
			},
		},
		["24401"] = {
			[1] = {
				[1] = BF["Cenarion Expedition"],
				[2] = "10",
				[3] = "250",
				[4] = "5",
			},
		},
		["24368"] = {
			[1] = {
				[1] = BF["Cenarion Expedition"],
				[2] = "1",
				[3] = "250",
				[4] = "8",
			},
		},
		["24449"] = {
			[1] = {
				[1] = BF["Sporeggar"],
				[2] = "10",
				[3] = "250",
				[4] = "4",
			},
		},
		["24291"] = {
			[1] = {
				[1] = BF["Sporeggar"],
				[2] = "10",
				[3] = "250",
				[4] = "4",
			},
		},
		["24246"] = {
			[1] = {
				[1] = BF["Sporeggar"],
				[2] = "1",
				[3] = "250",
				[4] = "8",
			},
		},
		["24245"] = {
			[1] = {
				[1] = BF["Sporeggar"],
				[2] = "10",
				[3] = "250",
				[4] = "4",
			},
		},
		["20404"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "10",
				[3] = "100",
				[4] = "8",
			},
		},
		["20513"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "3",
				[3] = "50",
				[4] = "8",
			},
		},
		["20514"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "3",
				[3] = "100",
				[4] = "8",
			},
		},
		["20515"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "3",
				[3] = "150",
				[4] = "8",
			},
		},
		["20800"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "1",
				[3] = "500",
				[4] = "8",
				[6] = L["Need Cenarion Tactical Badge and Cenarion Combat Badge"],
			},
		},
		["20801"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "1",
				[3] = "500",
				[4] = "8",
				[6] = L["Need Cenarion Logistics Badge and Cenarion Combat Badge"],
			},
		},
		["20802"] = {
			[1] = {
				[1] = BF["Cenarion Circle"],
				[2] = "1",
				[3] = "500",
				[4] = "8",
				[6] = L["Need Cenarion Logistics Badge and Cenarion Tactical Badge"],
			},
		},
		["12840"] = {
			[1] = {
				[1] = BF["Argent Dawn"],
				[2] = "20",
				[3] = "25",
				[4] = "8",
			},
		},
		["12841"] = {
			[1] = {
				[1] = BF["Argent Dawn"],
				[2] = "00",
				[3] = "25",
				[4] = "8",
			},
		},
		["12843"] = {
			[1] = {
				[1] = BF["Argent Dawn"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
			},
		},
		["12844"] = {
			[1] = {
				[1] = BF["Argent Dawn"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
			},
		},
		["21229"] = {
			[1] = {
				[1] = BF["Brood of Nozdormu"],
				[2] = "1",
				[3] = "1000",
				[4] = "8",
			},
		},
		["21230"] = {
			[1] = {
				[1] = BF["Brood of Nozdormu"],
				[2] = "1",
				[3] = "1000",
				[4] = "8",
			},
		},
		["11370"] = {
			[1] = {
				[1] = BF["Thorium Brotherhood"],
				[2] = "10",
				[3] = "75",
				[4] = "8",
			},
		},
		["17011"] = {
			[1] = {
				[1] = BF["Thorium Brotherhood"],
				[2] = "1",
				[3] = "200",
				[4] = "8",
			},
		},
		["17010"] = {
			[1] = {
				[1] = BF["Thorium Brotherhood"],
				[2] = "1",
				[3] = "200",
				[4] = "8",
			},
		},
		["17012"] = {
			[1] = {
				[1] = BF["Thorium Brotherhood"],
				[2] = "2",
				[3] = "150",
				[4] = "8",
			},
		},
		["11382"] = {
			[1] = {
				[1] = BF["Thorium Brotherhood"],
				[2] = "1",
				[3] = "200",
				[4] = "8",
			},
		},
		["18945"] = {
			[1] = {
				[1] = BF["Thorium Brotherhood"],
				[2] = "4",
				[3] = "25",
				[4] = "6",
			},
		},
		["19714"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19712"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19711"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19710"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19708"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19707"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19715"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19709"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "75",
				[4] = "8",
			},
		},
		["19858"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "50",
				[4] = "8",
			},
		},
		["19698"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Razzashi Coin and Hakkari Coin"],
 
			},
		},
		["19699"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Zulian Coin and Hakkari Coin"],
 
			},
		},
		["19700"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Zulian Coin and Razzashi Coin"],
 
			},
		},
		["19701"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Vilebranch Coin and Witherbark Coin"],
 
			},
		},
		["19702"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Gurubashi Coin and Witherbark Coin"],
 
			},
		},
		["19703"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Gurubashi Coin and Vilebranch Coin"],
 
			},
		},
		["19704"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Skullsplitter Coin and Bloodscalp Coin"],
 
			},
		},
		["19705"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Sandfury Coin and Bloodscalp Coin"],
 
			},
		},
		["19706"] = {
			[1] = {
				[1] = BF["Zandalar Tribe"],
				[2] = "1",
				[3] = "25",
				[4] = "8",
				[6] = L["Need Sandfury Coin and Skullsplitter Coin"],
 
			},
		},
	},
	Highest = true,

})

--[[--------------------------------------------------------------------------------
    OnEnable, enable the mod
-----------------------------------------------------------------------------------]]
function NextStep:OnEnable()
	self:HookTooltips()
    
    -- register for the Links add on
    self:RegisterEvent("Links_LinkOpened")
end

--[[--------------------------------------------------------------------------------
    OnDisable, disable the mod
-----------------------------------------------------------------------------------]]
function NextStep:OnDisable()
	for name, module in self:IterateModules() do
		self:ToggleModuleActive(module, false)
	end
    
    self:UnhookAll()
    self:UnregisterAllEvents()
end

--[[--------------------------------------------------------------------------------
    Hook Handlers
-----------------------------------------------------------------------------------]]
local tooltips = {
    -- Blizzard tooltips
	GameTooltip,
	ItemRefTooltip,
	-- AtlasLoot tooltip
	AtlasLootTooltip,
}

local getLinkFunctions = {
	SetLootItem			= GetLootSlotLink,
	SetLootRollItem		= function(id) return GetLootRollItemLink(id) end,
	SetHyperlink		= function(link) return link end,
	SetAuctionItem		= GetAuctionItemLink,
	SetBagItem			= GetContainerItemLink,
	SetCraftItem		= function(skill, id) return id and GetCraftReagentItemLink(skill, id) or GetCraftItemLink(skill) end,
	SetInventoryItem	= function(type, slot) if not this then return end return type and GetInventoryItemLink(type, slot) or GetContainerItemLink(BANK_CONTAINER,this:GetID()) end,
	SetQuestItem		= GetQuestItemLink,
	SetQuestLogItem		= GetQuestLogItemLink,
	SetTradePlayerItem	= GetTradePlayerItemLink,
	SetTradeSkillItem	= function(skill, id) return (id) and GetTradeSkillReagentItemLink(skill, id) or GetTradeSkillItemLink(skill) end,
	SetTradeTargetItem	= GetTradeTargetItemLink,
    SetInboxItem	    = GetInboxItemLink,
}

-- Hooking routine, loops all tooltips and functions and securely hooks
function NextStep:HookTooltips()
    for _, tooltip in pairs(tooltips) do
        if tooltip then
            for o, l in pairs(getLinkFunctions) do
                local originalFunction, linkFunction = o, l  -- Get these into a local context, to avoid errors.  This drove me nuts.
                
                local func = function(frame, arg1, arg2, arg3)
                    local link = linkFunction(arg1, arg2, arg3)
                    self:AddCountToTooltip(frame, link)
                end
                
                self:SecureHook(tooltip, originalFunction, func)
            end
        end
    end
end

--[[--------------------------------------------------------------------------------
    Event Handlers
-----------------------------------------------------------------------------------]]

-- respond to links opened by Links
function NextStep:Links_LinkOpened(link, frame)
    self:AddCountToTooltip(frame, link, 1, "Links")
end

--[[--------------------------------------------------------------------------------
    Utility functions
-----------------------------------------------------------------------------------]]
function NextStep:LinkToID(link)
	if link then
		local _, _, id = string.find(link, "(%d+):")
		return id
	end
end

function NextStep:AddTooltip(tooltip)
	if tooltip and type(tooltip) == "table" then
		table.insert(tooltips, tooltip)
		if self:IsActive() then
			self:AddCountToTooltip(tooltip)
		end
	end
end

function NextStep:GetFactionStanding(n)
	local name, standingID;

	for i=1, GetNumFactions(), 1 do
	        name, _, standingID  = GetFactionInfo(i);
		if name == n then
			return standingID
		end
	end
end

function NextStep:AddCountToTooltip(tooltip, link)
	if self.db.account.ItemInfo then
		local id = self:LinkToID(link) 
		local value = self.db.account.ItemInfo[id]
				
		if value ~= nil then
			local i = 1;
			while value[i] do
				local info = value[i]
				local numFactions = GetNumFactions();
				local factionIndex;
				local name, standingID, MinValue, MaxValue, CurrentValue

				for factionIndex=1, numFactions, 1 do
				        name, _, standingID, MinValue, MaxValue, CurrentValue = GetFactionInfo(factionIndex);
					if info[1] == name then
						if standingID > tonumber(info[4]) then
							tooltip:AddLine("NS:"..string.format(L["Your %s reputation is too high"], name), 1.0, 1.0, 0, 0)
						elseif standingID > 7 then
							tooltip:AddLine("NS:"..string.format(L["You are already exalted with %s."], name), 1.0, 1.0, 0, 0)
						elseif info[5] then
							local oppose, opposecheck, opposestanding
							_, _, oppose, opposecheck = string.find(info[5], "([^\|]+)|(%d+)")
							opposestanding = self:GetFactionStanding(oppose)
							if tonumber(opposecheck) < tonumber(opposestanding) then
								tooltip:AddLine("NS:"..string.format(L["It is unusable. Your %s reputation is %s."], oppose, getglobal("FACTION_STANDING_LABEL"..opposestanding)), 1.0, 1.0, 0, 0)
							else
								local count
								if self.db.account.Highest then
									count = math.floor((NS_Point[tonumber(info[4])] - NS_Point[tonumber(standingID)] - (CurrentValue - MinValue))/info[3])
									if ( count < ((NS_Point[tonumber(info[4])] - (CurrentValue - MinValue))/info[3]) ) then
										count = count + 1
									end
									tooltip:AddLine("NS:"..string.format(L["Need %dEA to go your %s reputation is %s(%d rep with %dEA)"], count*info[2], name, getglobal("FACTION_STANDING_LABEL"..tonumber(info[4])), info[3], info[2]), 1.0, 1.0, 0, 0)
								else
									count = math.floor((MaxValue - CurrentValue)/info[3])
									if ( count < ((MaxValue - CurrentValue)/info[3]) ) then
										count = count + 1
									end
									tooltip:AddLine("NS:"..string.format(L["Need %dEA to go your %s reputation is %s(%d rep with %dEA)"], count*info[2], name, getglobal("FACTION_STANDING_LABEL"..standingID+1), info[3], info[2]), 1.0, 1.0, 0, 0)
								end
							end
						else
							local count
							if self.db.account.Highest then
								count = math.floor((NS_Point[tonumber(info[4])] - NS_Point[tonumber(standingID)] - (CurrentValue - MinValue))/info[3])
								if ( count < ((NS_Point[tonumber(info[4])] - NS_Point[tonumber(standingID)] - (CurrentValue - MinValue))/info[3]) ) then
									count = count + 1
								end
								tooltip:AddLine("NS:"..string.format(L["Need %dEA to go your %s reputation is %s(%d rep with %dEA)"], count*info[2], name, getglobal("FACTION_STANDING_LABEL"..tonumber(info[4])), info[3], info[2]), 1.0, 1.0, 0, 0)
							else
								count = math.floor((MaxValue - CurrentValue)/info[3])
								if ( count < ((MaxValue - CurrentValue)/info[3]) ) then
									count = count + 1
								end
								tooltip:AddLine("NS:"..string.format(L["Need %dEA to go your %s reputation is %s(%d rep with %dEA)"], count*info[2], name, getglobal("FACTION_STANDING_LABEL"..standingID+1), info[3], info[2]), 1.0, 1.0, 0, 0)
							end
						end
						if info[6] and info[6] ~= nil then
							tooltip:AddLine("NS:"..info[6], 1.0, 1.0, 0, 0)
						end

					end
				end
				i = i + 1;
			end
			tooltip:Show()
		end
	end
end

